package com.liang.dao;

import com.liang.entity.SysPostInfo;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (SysPostInfo)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-27 17:14:56
 */
public interface SysPostInfoDao {

    /**
     * 通过ID查询单条数据
     *
     * @param postId 主键
     * @return 实例对象
     */
    SysPostInfo queryById(Integer postId);

    /**
     * 查询指定行数据
     *
     * @param sysPostInfo 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<SysPostInfo> queryAllByLimit(SysPostInfo sysPostInfo, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param sysPostInfo 查询条件
     * @return 总行数
     */
    long count(SysPostInfo sysPostInfo);

    /**
     * 查询岗位列表
     *
     * @param paraMap
     * @return
     */
    List<SysPostInfo> getSysPostInfoList(Map<String, String> paraMap);

    /**
     * 查询岗位列表
     *
     * @param paraMap
     * @return
     */
    List<SysPostInfo> getSysPostInfo1(Map<String, String> paraMap);


    /**
     * 获取岗位信息
     *
     * @param paraMap
     * @return
     */
    SysPostInfo getSysPostInfo(Map<String, String> paraMap);

    /**
     * 新增数据
     *
     * @param sysPostInfo 实例对象
     * @return 影响行数
     */
    int insert(SysPostInfo sysPostInfo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysPostInfo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysPostInfo> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysPostInfo> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SysPostInfo> entities);

    /**
     * 修改数据
     *
     * @param sysPostInfo 实例对象
     * @return 影响行数
     */
    int update(SysPostInfo sysPostInfo);

    /**
     * 通过主键删除数据
     *
     * @param postId 主键
     * @return 影响行数
     */
    int deleteById(Integer postId);

    /**
     * 批量删除操作日志
     *
     * @param
     * @return
     */
    int batchDelete(List<Integer> postIdList);

    /**
     * 岗位数据分页查询
     *
     * @return
     */
    List<SysPostInfo> list();


    List<SysPostInfo> getPost (Map map);
}

